---
layout: markdown_page
title: "APM Group"
---

# APM Group

## On this page
{:.no_toc}

- TOC
{:toc}

## Common links

* Slack channel: [#g_monitor_apm](https://gitlab.slack.com/archives/g_monitor_apm)
* Slack alias: TBD
* Google group: TBD

## Vision

...

## Mission

...

## Backend Team members

<%= direct_team(manager_role: 'Engineering Manager, Monitor APM') %>

## Frontend Team members

<%= direct_team(manager_role: 'Interim Frontend Engineering Manager, Monitor APM') %>

## Stable counterparts

<%= stable_counterparts(role_regexp: /[,&] Monitor/, direct_manager_role: 'Engineering Manager, Monitor Health', other_manager_roles: ['Engineering Manager, Monitor APM', 'Frontend Engineering Manager, Monitor Health', 'Interim Frontend Engineering Manager, Monitor APM']) %>

## Responsibilities
{: #monitoring}

The APM group is responsible for:
* Providing the tools required to enable monitoring of GitLab.com
* Packaging these tools to enable all customers to manage their instances easily and completely
* Building integrated monitoring solutions for customers apps into GitLab, including: metrics, logging, and tracing

This team maps to the [APM Group](/handbook/product/categories/#apm-group) category.

## How to work with Monitoring

### Adding new metrics to GitLab

The Monitor Group is responsible for providing the underlying libraries and tools to enable GitLab team-members to instrument their code. When adding new metrics, we need to consider a few facets: the impact on GitLab.com, customer deployments, and whether any default alerting rules should be provided.

Recommended process for adding new metrics:

1. Open an issue in the desired project outlining the new metrics desired
1. Label with the ~Monitoring label, and ping @gl-monitoring for initial review
1. During implementation consider:
  1. The Prometheus [naming](https://prometheus.io/docs/practices/naming/) and [instrumentation](https://prometheus.io/docs/practices/instrumentation/) guidelines
  1. Impact on cardinality and performance of Prometheus
  1. Whether any alerts should be created
1. Assign to an available Monitor Group reviewer

## Repos we own or use
* [Prometheus Ruby Mmap Client](https://gitlab.com/gitlab-org/prometheus-client-mmap) - The ruby Prometheus instrumentation lib we built, which we used to instrument GitLab
* [GitLab CE](https://gitlab.com/gitlab-org/gitlab-ce) and [GitLab EE](https://gitlab.com/gitlab-org/gitlab-ee) - Where much of the user facing code lives
* [Omnibus](https://gitlab.com/gitlab-org/omnibus-gitlab) and [Charts](https://gitlab.com/charts/charts.gitlab.io), where a lot of the packaging related work goes on. (We ship GitLab fully instrumented along with a Prometheus instance)

## Issue boards

* [APM](https://gitlab.com/groups/gitlab-org/-/boards/1143499) - Main board with all issues labeled "APM"
* [APM - Workflow](https://gitlab.com/groups/gitlab-org/-/boards/1165027) - Issue board organized by workflow label of "ready for development", "in dev", or "in review".

## Async Daily Standups
The purpose of our async standups is to allow every team member to have insight into what everyone else is doing and whether anyone is blocked and could use help. This should not be an exhaustive list of all of your tasks for the day, but rather a summary of the major deliverable you are hoping to achieve. All question prompts are optional. We use the [geekbot slack plugin](https://geekbot.io/) to automate our async standup in the [#g_monitor_standup](https://gitlab.slack.com/archives/g_monitor_standup) channel.

## Recurring Meetings
While we try to keep our process pretty light on meetings, we do have a few recurring meetings to keep in sync and to keep our backlog in good shape. We hold the [Monitor Group Weekly Meeting](https://docs.google.com/document/d/1yADA1ZfnflQjgSkbgJEEB6ziwE3iyb-_SCpjOOSHEPo/edit) to discuss agenda items that have been added over the course of the week and to walk through our current issue board together.

There is also an optional Monitor Social Hour meeting every week. This call has no agenda and alternates times every other week to be more inclusive of team members in different time zones.

## Monitor Stage PTO
Just like the rest of the company, we use [PTO Ninja](https://about.gitlab.com/handbook/paid-time-off/#pto-ninja) to track when team members are traveling, attending conferences, and taking time off. The easiest way to see who has upcoming PTO is to run the `/ninja whosout` command in the `#g_monitor_standup` slack channel. This will show you the upcoming PTO for everyone in that channel.
